#ifndef UTIL_H
#define UTIL_H

#include <complex>
#include <string>
#include "sha1.h"

// the base type is "double" (64 bits on x86/x87)
typedef double Real;
typedef std::complex<double> Cmplx;
typedef long double lReal;
#define fftw(name) fftw_ ## name
#define TYPE_STR ""

#ifndef _WIN32
#define _stdcall
#endif

// parses string as a positive integer, reporting errors
// to stderr and returning 1 in case of failure, 0 if success.
int parseint(char *str, int& res);

// additionally error is signalled if the number is <0
int parsepositiveint(char *str, int& res);

// parses string as a positive double, reporting errors
// to stderr and returning 1 in case of failure, 0 if success.
int parsedouble(char *str, double& res);

// additionally error is signalled if the number is <0
int parsepositivedouble(char *str, double& res);

/** convert sha1 to string */
std::string sha1tostring(SHA1 &sha1);

/** tolerant comparison of two double numbers */
bool tol_eq(double a, double b);

#endif
